// a trivial program to show how to get pixels on the screen

#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <gl/glaux.h>
#include <gl/gl.h>

// some types for later use
typedef unsigned char byte;
typedef byte rgb[3];			// these are 3 byte pixels in RGB order

int main(int argc, char* argv[])
{
	int width=512;
	int height=512;

	// get a window using the aux library
	auxInitDisplayMode(AUX_SINGLE |  AUX_RGB); // single buffered, rgb color
	auxInitPosition(0, 0, width, height);
	auxInitWindow(argv[0]);

	// allocate the framebuffer
	rgb* fb = new rgb[width*height];
	
	// draw into it
	for(int y=0; y<height; y++) {
		for(int x=0; x<width; x++) {
			rgb &p = fb[y*width+x];
			if(x==y) {
				p[0] = 255;
				p[1] = 0;
				p[2] = 0;
			} else if(x < y) {
				p[0] = 0;
				p[1] = 255;
				p[2] = 0;
			} else {
				p[0] = 0;
				p[1] = 0;
				p[2] = 255;
			}
		}
	}

	// show it on the screen
	glDrawPixels(width, height, GL_RGB, GL_UNSIGNED_BYTE,  fb);
	glFlush();
#ifdef _WIN32
	Sleep(2000);	// win32 wants the delay in ms
#else
	sleep(2);		// while the legacy os wants it in seconds
#endif
	return 0;
}